'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createReactElement;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ReactOnRails = require('./ReactOnRails');

var _ReactOnRails2 = _interopRequireDefault(_ReactOnRails);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Logic to either call the generatorFunction or call React.createElement to get the
 * React.Component
 * @param options
 * @param options.componentName
 * @param options.props
 * @param options.domNodeId
 * @param options.trace
 * @param options.location
 * @returns {Element}
 */
function createReactElement(_ref) {
  var componentName = _ref.componentName;
  var props = _ref.props;
  var domNodeId = _ref.domNodeId;
  var trace = _ref.trace;
  var location = _ref.location;

  if (trace) {
    console.log('RENDERED ' + componentName + ' to dom node with id: ' + domNodeId);
  }

  var componentObj = _ReactOnRails2.default.getComponent(componentName);

  // CONSIDER NOT RELEASING THE OPTION version
  var component = componentObj.component;
  var generatorFunction = componentObj.generatorFunction;

  if (generatorFunction) {
    return component(props, location);
  }

  return _react2.default.createElement(component, props);
}